// ARLO.H
//
// Copyright (c) 1998 Otfried Cheong
//

#ifndef __ARLO_H__
#define __ARLO_H__

#define KArloDriverName _L("ARLO")

class TCapsArLoV1
{
 public:
  TVersion version;
};

class RArLo : public RLogicalChannel
{
 public:
  enum {EMajorVersionNumber=0,
	EMinorVersionNumber=0,
	EBuildVersionNumber=0};
  enum {EBoot = 0, EExamine, ENoOfKernChunks, EKernChunkName };
 public:
  inline void Cancel();
  inline TInt Open(const TVersion& aVer)
    { return DoCreate(KArloDriverName, aVer, NULL, KNullUnit, NULL, NULL); }
  inline TVersion VersionRequired() const
    { return TVersion(EMajorVersionNumber, EMinorVersionNumber,
		      EBuildVersionNumber); }
  inline TInt Examine(TUint32 *anAddr)
    { return DoControl(EExamine, ((TAny *) anAddr)); }
  inline TInt Boot(TUint32 aPhysMapAdr, TUint32 aBootAdr)
    { return DoControl(EBoot, ((TAny *) aPhysMapAdr), ((TAny *) aBootAdr)); }
};

#endif
